/************************************************************************************************

       	Andr Rodigheri					Turma 241A			05141052
       	Eric Lucas Gavazzi Vazzoler		Turma 241A			05141176
		Roberto Carniel                 Turma 241B          05141400

		Calculadora de Matrizes
		
		Com este programa se faz a entrada de matrizes, e algumas operacoes entre elas, como soma,
	multiplicaao e transposta, quando possivel. Trabalha com matrizes com tamanho de ate 10x10,
	de elementos reais, com ate uma casa depois da virgula (para exibiao).

************************************************************************************************/


//Bibliotecas
#include <stdio.h>
#include <stdlib.h>


//Constantes
#define LINHAS_A tamanhos[0]
#define COLUNAS_A tamanhos[1]
#define LINHAS_B tamanhos[2]
#define COLUNAS_B tamanhos[3]


//Prototipos
int imprime_menu(void);
int entra_a(void);
int entra_b(void);
int soma_a_e_b(void);
int multiplica_a_e_b(void);
int a_transposta(void);
int apresenta_elemento_de_a(void);
int imprime_matriz(float [][], int, int, char[]);


/*Variaveis Globais

	Estas variaveis foram criadas como globais para permitir com mais facilidade que todas as funcoes tivessem
	acesso a elas.
*/
int tamanhos[4]={10,10,10,10}; // armazenara os tamanhos das matrizes A e B, de acordo com os #defines acima
float a[10][10]={{0.0},{0.0}}; // armazenara a matriz A
float b[10][10]={{0.0},{0.0}}; // armazenara a matriz B


//Principal
int main()
{
	int opcao=1;


	// Apresentao do programa para o usurio
	printf("******************************************************************\n");
	printf("\t\t   Calculadora de Matrizes\n\n");
	printf("Este programa podera realizar a soma e a multiplicacao\n");
	printf("de duas matrizes fornecidas. Tambem dara a transposta, ou mostrara\n");
	printf("qualquer um dos elementos da primeira matriz dada pelo usuario.\n\n");

	

	while(opcao!=0) // condicao de fim de programa
	{
		imprime_menu();
		printf("\nInforme o Numero da Opcao Desejada: ");
		scanf("%d",&opcao);
	 	while(opcao<0||opcao>6) // impede a entrada de opoes invalidas
		{
			printf("\nOpcao Invalida. Informe um numero entre 0 e 6: ");
			scanf("%d",&opcao);
  		}
		printf("\n");

		switch (opcao)  // chama a funcao que o usuario pediu.
		{
			case 1:
 				entra_a();
				break;
			case 2:
				entra_b();
				break;
			case 3:
				soma_a_e_b();
				break;
			case 4:
				multiplica_a_e_b();
				break;
			case 5:
				a_transposta();
				break;
			case 6:
				apresenta_elemento_de_a();
				break;
			default:
				break;
		}


	}

	return(0);
}


// funao que mostra na tela as opoes
int imprime_menu()
{
	printf("******************************************************************\n\n");
	printf("  (1)  Entra com a Matriz A\n");
	printf("  (2)  Entra com a Matriz B\n");
	printf("  (3)  Apresentar C = A + B na Tela\n");
	printf("  (4)  Apresentar C = A . B na Tela\n");
	printf("  (5)  Apresentar a Transposta de A na Tela\n");
	printf("  (6)  Apresentar um Elemento Especifico de A\n");
	printf("  (0)  Finalizar o Programa\n\n");
	printf("******************************************************************\n");
	return(0);
}


// funao que recebe a matriz A
int entra_a()
{
	/*
	    Essa funao recebe a matriz A que o usuario informar. Primeiro ele informa a largura e a altura da matriz.
		Depois o usuario informa os elementos da matriz um a um. Nessa etapa, eles sao indexados como no C,
		de 0 a linhas(ou colunas)-1.
		A funao impede a entrada de uma matriz maior que 10x10.
	*/
	int i, j;
	printf("\n\n  (1)  Entra com a Matriz A\n");
	
	printf("\nInforme o numero de Linhas de A: ");
	scanf("%d",&LINHAS_A);
	while(LINHAS_A<1||LINHAS_A>10) // impede a entrada de um numero de linhas invalido
		{
			printf("\nNumero de linhas Invalido. Informe um numero entre 1 e 10: ");
			scanf("%d",&LINHAS_A);
  		}
  		
	printf("\nInforme o numero de Colunas de A: ");
	scanf("%d",&COLUNAS_A);
	while(COLUNAS_A<1||COLUNAS_A>10) // impede a entrada de um numero de colunas invalido
		{
			printf("\nNumero de colunas Invalido. Informe um numero entre 1 e 10: ");
			scanf("%d",&COLUNAS_A);
  		}
  		
	for(i=0;i<=LINHAS_A-1;i++)      // recebendo os elementos da matriz
	{
		for(j=0;j<=COLUNAS_A-1;j++)
		{
			printf("\nDigite o termo A [%d][%d]: ",i+1,j+1);
			scanf("%f",&a[i][j]);
		}
	}
	printf("\n Entrada de Dados da matriz A concluida.\n");
	imprime_matriz(a, LINHAS_A, COLUNAS_A, "A");
	printf("\n\n");
	system("pause");
	printf("\n\n");
	return(0);
}


// funao que recebe a matriz B
int entra_b()
{
    //Funciona da mesma forma que a funao entra_a

	int i, j;
	printf("\n\n  (2)  Entra com a Matriz B\n");

	printf("\nInforme o numero de Linhas de B: ");
	scanf("%d",&LINHAS_B);
	while(LINHAS_B<1||LINHAS_B>10)
		{
			printf("\nNumero de linhas Invalido. Informe um numero entre 1 e 10: ");
			scanf("%d",&LINHAS_B);
  		}
  		
	printf("\nInforme o numero de Colunas de B: ");
	scanf("%d",&COLUNAS_B);
	while(COLUNAS_B<1||COLUNAS_B>10)
		{
			printf("\nNumero de colunas Invalido. Informe um numero entre 1 e 10: ");
			scanf("%d",&COLUNAS_B);
  		}

	for(i=0;i<=LINHAS_B-1;i++)
	{
		for(j=0;j<=COLUNAS_B-1;j++)
		{
			printf("\nDigite o termo B [%d][%d]: ",i+1,j+1);
			scanf("%f",&b[i][j]);
		}
	}
	printf("\n Entrada de Dados da matriz B concluida.\n\n");
	imprime_matriz(b, LINHAS_A, COLUNAS_A, "B");
	printf("\n\n");
	system("pause");
	printf("\n\n");
	return(0);
}


// funao que soma A e B
int soma_a_e_b()
{
	/*
	    Essa funao verifica se a soma eh possivel (A e B de mesmo tamanho), e entao faz a soma.
	*/
    printf("\n\n  (3)  Apresentar C = A + B na Tela\n");
	if((LINHAS_A==LINHAS_B)&&(COLUNAS_A==COLUNAS_B))
	{
  		int i, j;
  		float soma[10][10];


  		for(i=0;i<=LINHAS_A-1;i++)
  		{
			for(j=0;j<=COLUNAS_A-1;j++)
			{
                soma[i][j]=0;
				soma[i][j]=a[i][j]+b[i][j];
			}
		}
		imprime_matriz(soma, LINHAS_A, COLUNAS_A, "A+B");

	}
	else
	{
		printf("\nNao eh possivel somar as matrizes A e B, pois elas nao tem o mesmo tamanho:");
		printf("\nA matriz A eh %dx%d e a matriz B eh %dx%d.\n\n",LINHAS_A,COLUNAS_A,LINHAS_B,COLUNAS_B);
	}
	system("pause");
	printf("\n\n");
	return(0);
}


// funao que multiplica A por B
int multiplica_a_e_b()
{
	/*
	    Essa funao verifica se a multiplicaao eh possivel (numeros de colunas de A igual ao de linhas de B),
		e entao faz a multiplicao das matrizes.
	*/
    printf("\n\n  (4)  Apresentar C = A . B na Tela\n");
	if(COLUNAS_A==LINHAS_B)
	{
		int i, j;
		int x;
		float multiplicacao[10][10];

		for(i=0;i<=LINHAS_A-1;i++)
		{
			for(j=0;j<=COLUNAS_B;j++)
			{
				multiplicacao[i][j]=0;
				for(x=0;x<=COLUNAS_A;x++)
				{
					multiplicacao[i][j] += a[i][x]*b[x][j];
				}
			}
		}
		imprime_matriz(multiplicacao, LINHAS_A, COLUNAS_B, "A.B");
		system("pause");
		printf("\n\n");
	}
	else
	{
	    printf("\nNao eh possivel multiplicar as matrizes A e B, pois o numero de colunas de A nao eh igual ao numero de linhas de B:");
	    printf("\nA matriz A eh %dx%d e a matriz B eh %dx%d.\n\n",LINHAS_A,COLUNAS_A,LINHAS_B,COLUNAS_B);
		system("pause");
		printf("\n\n");
	}
	return(0);
}


// funao que apresenta a transposta de A
int a_transposta()
{
    printf("\n\n  (5)  Apresentar a Transposta de A na Tela\n");
	int i,j;
	float transposta_de_a[10][10];

	for(i=0;i<=COLUNAS_A-1;i++)
	{
		for(j=0;j<=LINHAS_A-1;j++)
		{
			transposta_de_a[i][j]=a[j][i];
		}
	}
	
	imprime_matriz(transposta_de_a, COLUNAS_A, LINHAS_A, "Transposta de A");
	system("pause");
	printf("\n\n");
 	return(0);
}


// funao que apresenta um termo da matriz A pedido pelo usuario
int apresenta_elemento_de_a()
{
	int i,j;
	
    printf("\n\n  (6)  Apresentar um Elemento Especifico de A\n");
    
	printf("\nInforme a linha do elemento desejado: ");
	scanf("%d",&i);
	while((i>LINHAS_A)||(i<1))
	{
		printf("\nEntrada Invalida. A matriz A tem %d linha(s).\n",LINHAS_A);
		printf("Informe a linha do elemento desejado: ");
		scanf("%d",&i);
	}
	
	printf("\nInforme a coluna do elemento desejado: ");
	scanf("%d",&j);
	while((j>COLUNAS_A)||(j<1))
	{
		printf("\nEntrada Invalida. A matriz A tem %d coluna(s).\n",COLUNAS_A);
		printf("Informe a coluna do elemento desejado: ");
		scanf("%d",&j);
	}
	
	printf("\nElemento A[%d][%d] = %5.1f.\n\n",i,j,a[i-1][j-1]);
	system("pause");
	printf("\n\n");
	return(0);
}


// funao que imprime as matrizes de maneira formatada na tela
int imprime_matriz(float matriz[][10],int linhas, int colunas, char nome[])
{
/*
	A funao recebe 4 parametros: a matriz a ser impressa, o numero de linhas dela, o numero de colunas dela,
	e um nome para essa matriz. A partir disso, ela imprime a matriz como a seguir:

Matriz NOME =
	PARTE 1			 _    <=		 _                                    _
					|				|   5.0   4.0   6.0   8.0   2.0   3.0  |
					|				|                                      |
	PARTE 2		   <				|   8.0   7.0   6.0   8.0   4.0   7.0  |
					|_				|                                      |
	PARTE 3				  <=		|_  2.0   5.0   4.0   3.0   8.0   9.0 _|

	Para nao perder a formataao, os elementos da matriz nao podem ser maiores que 99.
*/

	int i,j;

	printf("\nMatriz %s =\n",nome); // imprime Matriz <nome da matriz>

	printf("%16s_ "," ");           // imprime a PARTE 1 do esquema.
	for(i=0;i<=colunas-1;i++)
 		printf("%5s"," ");
	printf(" _\n");

	for(i=0;i<=linhas-2;i++)        // imprime a PARTE 2 do esquema.
	{
		printf("%15s|  "," ");
		for(j=0;j<=colunas-1;j++)
  			printf("%5.1f",matriz[i][j]);
		printf("  |\n");
		printf("%15s|  "," ");
		for(j=0;j<=colunas-1;j++)
  			printf("%5s"," ");
  		printf("  |\n");
	}
	
	printf("%15s|_ "," ");          // imprime a PARTE 3 do esquema.
	for(j=0;j<=colunas-1;j++)
	    printf("%5.1f",matriz[linhas-1][j]);
	printf(" _|\n\n");

	return (0);
}
